let createDOMPurify = require('dompurify');
let { JSDOM } = require('jsdom');

let window = new JSDOM('').window;
let DOMPurify = createDOMPurify(window);
var escaped_str = require('querystring')
const Errors = require('../lib/errors')
let pagination = require('../lib/pagination.js')


module.exports = (sequelize, DataTypes) => {
    let Relationship = sequelize.define('Relationship', {
        type: {
            type: DataTypes.ENUM,
            defaultValue: "1",
            values: ['pending', 'accepted', 'ignored', 'pendingCanAccept'],
            validate: {
                isIn: {
                    args: [['pending', 'accepted', 'ignored', 'pendingCanAccept']],
                    msg: "Answer can only be one of the pre-defined options"
                }
            }
        },
    })
    Relationship.associate = function (models) {
        Relationship.belongsTo(models.User, { as: 'friend1'})
        Relationship.belongsTo(models.User, { as: 'friend2'})
    }

    return Relationship
}
